package jp.gihyo.mitoma.android.s1601recycerview;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.recyclerview.widget.RecyclerView;

import org.jspecify.annotations.NonNull;

import java.util.ArrayList;

public class MyAdapter extends RecyclerView.Adapter<MyAdapter.ViewHolder> {
    // クリックリスナーインターフェース
    public interface OnMyClickListener {
        void onItemClick(View view, int position);
        void onItemLongClick(View view, int position);
    }

    private ArrayList<FriendsDTO> friendsList;
    private ArrayList<Integer> imageList;
    private OnMyClickListener myListener;

    // コンストラクタで表示データを受け取る
    public MyAdapter(ArrayList<FriendsDTO> friendsList,ArrayList<Integer> imageList) {

        this.friendsList = friendsList;
        this.imageList = imageList;
    }
    // クリックリスナーのセッター
    public void setOnMyClickListener(OnMyClickListener myListener){
        this.myListener = myListener;
    }
    // ビューホルダの生成
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        // 1行分のレイアウトを生成
        View itemView = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.item_layout, parent, false);
        return new ViewHolder(itemView,myListener);
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        // 指定位置のデータをTextViewに設定
        FriendsDTO dto = friendsList.get(position);
        int imageNo = imageList.get(position);
        holder.friendImage.setImageResource(imageNo);
        holder.tvID.setText(dto.id);
        holder.tvName.setText(dto.name);
        holder.tvPhone.setText(dto.phone);

        //ここでセットする場合、以下をコメント解除にする
        /* *** リスナーをセットする******************************************
        //**クリック***
        holder.tvName.setOnClickListener(v ->{
            myListener.onItemClick(v,position);}
        );

        holder.itemView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                listener.onItemClick(v, position);
            }
        });
        //**長押し ***
        holder.itemView.setOnLongClickListener(v -> {
            myListener.onItemLongClick(v, position);
            return true;});
       ****************************************************************** */
    }
    public int getItemCount() {
        return friendsList.size();
    }
    // --- ViewHolder クラス ---
    public static class ViewHolder extends RecyclerView.ViewHolder {
        ImageView friendImage;
        TextView tvID;
        TextView tvName;
        TextView tvPhone;
        public ViewHolder(@NonNull View itemView,OnMyClickListener myListener) {
            super(itemView);
            friendImage = itemView.findViewById(R.id.friendImage);
            tvID = itemView.findViewById(R.id.tvID);
            tvName = itemView.findViewById(R.id.tvName);
            tvPhone = itemView.findViewById(R.id.tvPhone);

            // **ラムダ式でセット**************************************************
            tvName.setOnClickListener(v ->{
                myListener.onItemClick(v,getBindingAdapterPosition());}
            );
            itemView.setOnLongClickListener(v ->{
                myListener.onItemLongClick(v,getBindingAdapterPosition());
                return true;
            });
            // ******************************************************************
            /* **匿名クラスでセット************************************************

            tvName.setOnClickListener(new View.OnClickListener() {
                public void onClick(View v) {
                    myListener.onItemClick(v, getBindingAdapterPosition());
                }
            });
            itemView.setOnLongClickListener(new View.OnLongClickListener() {
                @Override
                public boolean onLongClick(View v) {
                    myListener.onItemLongClick(v, getBindingAdapterPosition());
                    return false;
                }
            });
            ****************************************************************** */
        }
    }
}